var baseurl = "http://zhushou.huihui.cn/";
var UPVERSION_URL = baseurl + "api/zhushou/upversion";
var URL_INSTALL = baseurl + 'installed?browser=sogou';
var URL_UPDATE = baseurl + 'updatelog?browser=sogou';

// 写死browser
var browser = 'sogou';
var vendor = "sogounew";

/* JS Option String Object */
function StrOpt(optstr) {
    if (!optstr) optstr = "";
    var argstrs = optstr.split(';');
    for (var i = 0; i < argstrs.length; ++i) {
        var pos = argstrs[i].search('=');
        if (pos != -1) {
            var name = argstrs[i].substring(0, pos);
            this[name] = argstrs[i].substr(pos+1);
        }
    }
}
StrOpt.prototype.toOptString = function() {
    var str = "";
    for (var name in this) {
        if (this.hasOwnProperty(name)) {
            if (isFunction(this[name])) continue;
               str += name + "=" + this[name] + ";";
        }
    }
    return str;
};

// 初始化LocalStorage {browser, vendor, guid, version}
(function initLocalStorage() {
    // 每次都覆盖browser
    set('browser', browser);

    // 本地没有vendor则更新
    if (get('vendor') == undefined) {
        set('vendor', vendor);
    }

    // 只有不存在的时候再生成guid(extensionid),
    if (get('guid') == undefined) {
        set('guid', genExtensionId());
    }

    // 每次都覆盖version
    var currVersion = sogouExplorer.runtime.getManifest().version;
    var prevVersion = get('version');
    set('version', currVersion);
    // 如果当前插件版本与LocalStorage存储的版本不一样，则需要升级。
    if (currVersion != prevVersion) {
        // 注意onInstall和onUpdate中的sendLog需要依赖一些LocalStorage值，因此这块要放在最后
        if (prevVersion == undefined) {
            onInstalled();
        } else {
            onUpdated(prevVersion, currVersion);
        }
        // 版本有变化的情况下也要设置upversion防止多次弹出升级页面
        setupversion();
    } else {
        // 加入extension.js升级弹出更新页的逻辑
        simpleAjax(UPVERSION_URL, function (json) {
            var upVersion = get('upversion');
            if (json.doupdate == "true" && json.version != upVersion) {
                set('upversion', json.version);
                onUpdated("0.0.0", "0.1.0");
            }
        });
    }

    // 设置 youdaoGWZS_jsOptions
    var options = new StrOpt(get('youdaoGWZS_jsOptions'));
    options["browser"] = get('browser');
    options["vendor"] = "sogounew";
    options["extensionid"] = get('guid');
    options["version"] = get('version');
    options["apiVersion"] = '3.0';
    set('youdaoGWZS_jsOptions', options.toOptString());
})();

(function sendHeartBeat() {
    var last = get('lastheartbeat');
    var today = (new Date).getDate();
    if (last && last == today) return;

    sendLog(["action=SOGOU_HEARTBEAT", "type=ARMANI_EXTENSION_HEARTBEAT"]);
    set('lastheartbeat', today);
})();


/* 读取商家列表 */
(function updateConfig() {
    var xhr;
    /* step 1: 先从本地xml文件更新 */
    if (!get('mre_txt')) {
        xhr = new XMLHttpRequest();
        xhr.open('GET', sogouExplorer.extension.getURL('config.xml'), false);
        xhr.send(null);
        parseConfigXML(xhr.responseXML.documentElement);
    }

    /* step 2: 每天从服务器更新一次 */
    var last = get('last_update_hour');
    var now = (new Date).getHours();
    if (!last || last != now) {
        xhr = new XMLHttpRequest();
        xhr.open('GET', baseurl + 'extensions/config.xml', true);
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                parseConfigXML(xhr.responseXML.documentElement);
                set('last_update_hour', now);
            } 
        };
        xhr.send(null);
    }
})();


sogouExplorer.extension.onRequest.addListener(function(request, sender, sendResponse) {
    switch (request.type) {
        case 'info':
            sendResponse({
                vendor: vendor,
                version: get('version'),
                option: get('youdaoGWZS_jsOptions'),
                matched: get('mre_txt'),
                blocked: get('bre_txt'),
                gray: get('gre_txt'),
                redirect: get('rre_txt'),
                conf: get('parse_conf'),
                huihui_reffer: get('HUIHUI_reffer')
            });
            break;
        case 'setOptions':
            set('youdaoGWZS_jsOptions', request.optionstr);
            break;
        case 'reffer':
            var rre = get('rre_txt');
            if(rre){
                var isSet = (new RegExp(rre, 'i')).test(request.url);
                isSet && setReffer(request.reffer,request.url);
            }
            break;
        default: 
            sendResponse({});
    }
});

//open introduction page when installed
function onInstalled() {
    sendLog(["action=INSTALL_SOGOU", "type=ARMANI_EXTENSION_EXINSTALL"]);
    var o = new StrOpt(get("youdaoGWZS_jsOptions"));
    o["state"] = "install";
    set("youdaoGWZS_jsOptions", o.toOptString());
    sogouExplorer.tabs.create({
        selected: true, 
        url: URL_INSTALL + '&version=' + get('version') +
        '&vendor=' + vendor
    });
}

//open introduction page when major updated
function onUpdated(prevVersion, currVersion) {
    var o = new StrOpt(get("youdaoGWZS_jsOptions"));
    o["state"] = "update";
    set("youdaoGWZS_jsOptions", o.toOptString());
    if (prevVersion.split('.')[1] !== currVersion.split('.')[1]) {
        sendLog(["action=UPDATE_SOGOU", "type=ARMANI_EXTENSION_EXUPDATE", "uptab=true"]);
        sogouExplorer.tabs.create({
            selected: true,
            url: URL_UPDATE + '&version=' + get('version') +
            '&vendor=' + vendor
        });
    } else {
        sendLog(["action=UPDATE_SOGOU", "type=ARMANI_EXTENSION_EXUPDATE", "uptab=false"]);
    }
}

function parseConfigXML(doc) {
    if (!doc) return;
    
    var b = doc.getElementsByTagName("blocked")[0];
    var bre = b.lastChild.nodeValue;
    if (bre) set('bre_txt', bre);
    
    var m = doc.getElementsByTagName("matched")[0];
    var mre = m.lastChild.nodeValue;
    if (mre) set('mre_txt', mre);

    var r = doc.getElementsByTagName("redirect")[0];
    var rre = r.lastChild.nodeValue;
    if (rre) set('rre_txt', rre);

    var g = doc.getElementsByTagName("gray")[0];
    var gre = g.lastChild.nodeValue;
    if (gre) set('gre_txt', gre);

    var c = doc.getElementsByTagName("conf")[0];
    var conf = c.lastChild.nodeValue;
    if (conf) set('parse_conf', conf);
}

function isFunction(obj) {
    var getType = {};
    return obj && getType.toString.call(obj) == '[object Function]';
}

function get(key) {
    return localStorage[key];
}

function set(key, val) {
    localStorage[key] = val;
}

function sendLog(logParams) {

    var logUrlPrefix = "http://zhushou.huihui.cn/log?" +
        "browser=" + get('browser') +
        "&vendor=" + vendor +
        "&extensionid=" + get('guid') +
        "&version=" + get('version') + '&';
    var finalLogUrl = logUrlPrefix + logParams.join("&");
    var img = document.createElement('img');
    img.setAttribute('src', finalLogUrl);
    img.setAttribute('style', 'display:none');
}

function genExtensionId() {
    var guid = "";
    for (var i = 1; i <= 32; ++i) {
        guid += Math.floor(Math.random()*16.0).toString(16);
        if((i==8)||(i==12)||(i==16)||(i==20))
            guid += "-";
    }
    return guid;
}

function getSession(key) {
    return sessionStorage.getItem(key);
}

function setSession(key, val) {
    sessionStorage.setItem(key,val);
}
function setReffer(reffer,nowUrl){
    //getAllRefferSession();
    var _str = reffer+'|' + nowUrl,
        _value = get('HUIHUI_reffer');
    if(_value && _value.length < 5000){
        if(_value.indexOf(_str) > -1){
            return false;
        }else{
            checkSetHuihuiReffer(reffer,nowUrl);
        }
    }else{
        set('HUIHUI_reffer',reffer +'|'+nowUrl);
    }
}

function checkSetHuihuiReffer(reffer,nowUrl){
    var _value = get('HUIHUI_reffer'),
        _arr = _value.split(','),
        len = _arr.length,
        nowArr, last,
        newHUIHUI_reffer;
    for(var i = 0; i < len; i++){
        nowArr = _arr[i].split('|');
        last = nowArr.pop();
        //如果查找到有
        if(last == reffer && last != nowUrl){
            newHUIHUI_reffer = _value.replaceAll(_arr[i],_arr[i]+'|'+nowUrl);
            break;
        }
    }
    if(newHUIHUI_reffer){
        set('HUIHUI_reffer',newHUIHUI_reffer);
    }else{
        set('HUIHUI_reffer',_value + ',' + reffer +'|'+nowUrl);
    }
}

function simpleAjax(url, callback) {
    var httpRequest = new XMLHttpRequest();
    httpRequest.onreadystatechange = function () {
        if (httpRequest.readyState === 4) {
            if (httpRequest.status === 200) {
                var msgs = unserialize(httpRequest.responseText);
                callback.call(this, msgs);
            } else {
                console.log(httpRequest.status);
            }
        }
    };
    httpRequest.open("get", url);
    httpRequest.send();
}

function setupversion() {
    simpleAjax(UPVERSION_URL, function (json) {
        set('upversion', json.version);
    });
}

function unserialize(text) {
    if (typeof JSON === "undefined") {
        throw new Error("unserialize depends on JSON!");
    }
    try {
        var json = JSON.parse(text);
    } catch (e) {
        return false;
    }
    return json;
}