/* notebook: sogou has two modes : compatible mode(ie7) and high speed mode(webkit) 
 *           we should detect which browsing mode the content script running in */

var isInExtension = true;
(function com_sogou_YoudaoGouwu () {
    var ZHUSHOU_HOST = location.protocol == 'https:' ? '//shared-https.ydstatic.com/gouwuex/ext/script/'
        :'//shared.ydstatic.com/gouwuex/ext/script/';
    var ZHUSHOU_SRC = 'extension_3_1.js';
    var vendor = "";
    var version = "";
    var optstr = "";
    var MRE = "";
    var BRE = "";
    var GRE = "";
    var RRE = "";
    var crconf = "";
    var huihui_reffer = "";
    /* JS Option String Object */
    function StrOpt(optstr) {
        if (!optstr) optstr = "";
        var argstrs = optstr.split(';');
        for (var i = 0; i < argstrs.length; ++i) {
            var pos = argstrs[i].search('=');
            if (pos != -1) {
                var name = argstrs[i].substring(0, pos);
                this[name] = argstrs[i].substr(pos+1);
            }
        }
    }
    StrOpt.prototype.toOptString = function() {
        var str = "";
        for (var name in this) {
            if (this.hasOwnProperty(name)) {
                if (isFunction(this[name])) continue;
                str += name + "=" + this[name] + ";";
            }
        }
        return str;
    };
    function isFunction(obj) {
        var getType = {};
        return obj && getType.toString.call(obj) == '[object Function]';
    }
    (function init() {

        sogouExplorer.extension.sendRequest(
            {type: 'reffer', reffer: document.referrer,url: document.location.href}, function(){
                //nthing
            }
        );
        sogouExplorer.extension.sendRequest({type: 'info'}, function(response) {
            vendor = response.vendor;
            version = response.version;
            optstr = response.option;
            MRE = response.matched;
            BRE = response.blocked;
            GRE = response.gray;
            RRE = response.redirect;
            crconf = response.conf;
            huihui_reffer = response.huihui_reffer;
            load();
        });
    })();

    function load() {
        function setOption(opt) {
            sogouExplorer.extension.sendRequest(
                {type: 'setOption', optionstr: opt}, null
            );
        }

        function isShow() {
            if (self != top) {
                return false;
            }
            if (!MRE || !BRE) return false;
            var m = (new RegExp(MRE, 'i')).test(document.location.href);
            var b = (new RegExp(BRE, 'i')).test(document.location.href);
            var g = (new RegExp(GRE, 'i')).test(document.location.href);
            return (m || g) && !b;
        }
        function isGray(){
            if (!GRE) return false;
            return (new RegExp(GRE, 'i')).test(document.location.href);
        }

        (function () {
            if (!isShow()) return;

            var opnode = document.getElementById('youdaoGWZS_options');
            if (opnode) return;

            var wr = document.createElement("span");
            wr.id = "youdao_gouwu";
            wr.style.display = 'none';

            var conf = document.createElement("span");
            conf.id = "youdaoGWZS_config";
            conf.innerText = encodeURIComponent(crconf);
            wr.appendChild(conf);

            var reffer = document.createElement("span");
            reffer.id = "youdaoGWZS_reffer";
            reffer.innerText = huihui_reffer;
            wr.appendChild(reffer);

            var opt = new StrOpt(optstr);
            opt.isGray = isGray();
            opnode = document.createElement('span');
            opnode.id = 'youdaoGWZS_options';
            wr.appendChild(opnode);
            document.getElementsByTagName('body')[0].appendChild(wr);
            opnode.innerText = opt.toOptString();
            
            var prev = opnode.innerText;
            var monitor = function () {
                if (opnode.innerText !== prev) {
                    prev = opnode.innerText;
                    sogouExplorer.extension.sendRequest({
                        type: 'setOptions', optionstr: opnode.innerText
                    });
                }
                setTimeout(arguments.callee, 500);
            };
            setTimeout(monitor, 500);

            if (window.youdao && window.youdao.cache) {
                return;
            }

            //whether in iframe
            if (window.self !== window.top) {
                return;
            }
            var href = location.href,
                isAliCSP = !!(href.match(/^http(?:s)?:\/\/([a-zA-Z0-9-_]+\.)*(tmall|taobao)\./)) && !!(document.querySelector('meta[http-equiv=Content-Security-Policy]')),
                isVipCSP = !!(href.match(/^http(?:s)?:\/\/([a-zA-Z0-9-_]+)\.vip\.com\/?(.*)?(\?.*)?$/));

            if(isAliCSP || isVipCSP){
                extension_js();
            }else{
                addScriptx()(ZHUSHOU_HOST + ZHUSHOU_SRC);
            }
        })();

    }


    function isType(type) {
        return function (obj) {
            return {}.toString.call(obj) == "[object " + type + "]"
        }
    }
    var isUndefined = isType("Undefined");
    function addScriptx() {
        var doc = document;
        var head = doc.head || doc.getElementsByTagName("head")[0] || doc.documentElement
        var currentlyAddingScript

        function request(url, callback, charset, crossorigin) {
            var node = doc.createElement("script")

            if (charset) {
                node.charset = charset
            }

            if (!isUndefined(crossorigin)) {
                node.setAttribute("crossorigin", crossorigin)
            }

            addOnload(node, callback, url)

            node.async = true
            node.src = url
            node.charset='utf-8'

            // For some cache cases in IE 6-8, the script executes IMMEDIATELY after
            // the end of the insert execution, so use `currentlyAddingScript` to
            // hold current node, for deriving url in `define` call
            currentlyAddingScript = node
            head.appendChild(node)

            currentlyAddingScript = null
        }

        function addOnload(node, callback, url) {
            var supportOnload = "onload" in node

            if (supportOnload) {
                node.onload = onload
                node.onerror = function() {
                    onload(true)
                }
            } else {
                node.onreadystatechange = function() {
                    if (/loaded|complete/.test(node.readyState)) {
                        onload()
                    }
                }
            }

            function onload(error) {
                // Ensure only run once and handle memory leak in IE
                node.onload = node.onerror = node.onreadystatechange = null

                // Remove the script to reduce memory leak
                try{head.removeChild(node)}catch(e){}

                // Dereference the node
                node = null

                //callback(error)
            }
        }

        return function(url, callback) {
            request(url,callback)
        }
    }
})();
